#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _a;
exports.__esModule = true;
var axios_1 = require("axios");
var fs = require("fs");
var BLOCKED_TEXT = 'Forbidden: bot was blocked by the user';
var DEACTIVATED_TEXT = 'Forbidden: user is deactivated';
var NO_CHAT = 'Bad Request: chat not found';
var KICKED = 'Forbidden: bot was kicked from the group chat';
var CHAT_UPGRADED = 'Bad Request: group chat was upgraded to a supergroup chat';
var CHAT_DELETED = 'Forbidden: the group chat was deleted';
var CHAT_WRITE_FORBIDDEN = 'Bad Request: CHAT_WRITE_FORBIDDEN';
var PEER_ID_INVALID = 'Bad Request: PEER_ID_INVALID';
var NO_RIGHTS = 'Bad Request: have no rights to send a message';
var SG_NO_MEMBER = 'Forbidden: bot is not a member of the supergroup chat';
var SG_KICKED = 'Forbidden: bot was kicked from the supergroup chat';
var CHANNEL_PRIVATE = 'Bad Request: CHANNEL_PRIVATE';
var ENOTFOUND = 'getaddrinfo ENOTFOUND api.telegram.org';
var MAX_THREADS = 20;
var FG_BG_RESET = '\x1b[0m';
var BG_BLUE_FG_YELLOW = '\x1b[44m\x1b[33m';
var errorLog = [];
var Status;
(function (Status) {
    Status[Status["BLOCKED"] = 0] = "BLOCKED";
    Status[Status["OK"] = 1] = "OK";
    Status[Status["DEACTIVATED"] = 2] = "DEACTIVATED";
    Status[Status["NO_CHAT"] = 3] = "NO_CHAT";
    Status[Status["KICKED"] = 4] = "KICKED";
    Status[Status["CHAT_UPGRADED"] = 5] = "CHAT_UPGRADED";
    Status[Status["CHAT_DELETED"] = 6] = "CHAT_DELETED";
    Status[Status["CHAT_WRITE_FORBIDDEN"] = 7] = "CHAT_WRITE_FORBIDDEN";
    Status[Status["PEER_ID_INVALID"] = 8] = "PEER_ID_INVALID";
    Status[Status["NO_RIGHTS"] = 9] = "NO_RIGHTS";
    Status[Status["SG_NO_MEMBER"] = 10] = "SG_NO_MEMBER";
    Status[Status["SG_KICKED"] = 11] = "SG_KICKED";
    Status[Status["CHANNEL_PRIVATE"] = 12] = "CHANNEL_PRIVATE";
    Status[Status["OTHER"] = 13] = "OTHER";
})(Status || (Status = {}));
var MAP_STATUSES = (_a = {},
    _a[BLOCKED_TEXT] = Status.BLOCKED,
    _a[DEACTIVATED_TEXT] = Status.DEACTIVATED,
    _a[NO_CHAT] = Status.NO_CHAT,
    _a[KICKED] = Status.KICKED,
    _a[CHAT_UPGRADED] = Status.CHAT_UPGRADED,
    _a[CHAT_WRITE_FORBIDDEN] = Status.CHAT_WRITE_FORBIDDEN,
    _a[PEER_ID_INVALID] = Status.PEER_ID_INVALID,
    _a[NO_RIGHTS] = Status.NO_RIGHTS,
    _a[SG_NO_MEMBER] = Status.SG_NO_MEMBER,
    _a[SG_KICKED] = Status.SG_KICKED,
    _a[CHANNEL_PRIVATE] = Status.CHANNEL_PRIVATE,
    _a[CHAT_DELETED] = Status.CHAT_DELETED,
    _a);
var _b = process.argv, botToken = _b[2], fileName = _b[3];
var data = fs.readFileSync(fileName, 'utf-8');
var ids;
if (fileName.endsWith('.json')) {
    ids = JSON.parse(data).map(function (idNode) {
        if (typeof idNode === 'number') {
            return idNode;
        }
        else {
            return typeof idNode.id === 'number'
                ? idNode.id
                : parseInt(idNode.id.$numberLong); // some data from mongoDb export may be like `{ '$numberLong': '-10015516.....' }`
        }
    });
}
else if (fileName.endsWith('.txt')) {
    ids = data.split('\n').filter(function (it) { return Boolean(it); }).map(function (it) { return parseInt(it); });
}
else {
    console.error('Wrong data');
    process.exit();
}
var resultMap = new Map();
var statusMap = new Map();
var echo = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p;
    console.clear();
    var lines = "OK: ".concat((_a = statusMap.get(Status.OK)) !== null && _a !== void 0 ? _a : 0, "\n                 BLOCKED: ").concat((_b = statusMap.get(Status.BLOCKED)) !== null && _b !== void 0 ? _b : 0, "\n                 DEACTIVATED: ").concat((_c = statusMap.get(Status.DEACTIVATED)) !== null && _c !== void 0 ? _c : 0, "\n                 NO_CHAT: ").concat((_d = statusMap.get(Status.NO_CHAT)) !== null && _d !== void 0 ? _d : 0, "\n                 KICKED: ").concat(((_e = statusMap.get(Status.KICKED)) !== null && _e !== void 0 ? _e : 0) + ((_f = statusMap.get(Status.SG_KICKED)) !== null && _f !== void 0 ? _f : 0), "\n                 UPGRADED: ").concat((_g = statusMap.get(Status.CHAT_UPGRADED)) !== null && _g !== void 0 ? _g : 0, "\n                 DELETED: ").concat((_h = statusMap.get(Status.CHAT_DELETED)) !== null && _h !== void 0 ? _h : 0, "\n                 WRITE_FORBIDDEN: ").concat((_j = statusMap.get(Status.CHAT_WRITE_FORBIDDEN)) !== null && _j !== void 0 ? _j : 0, "\n                 PEER_ID_INVALID: ").concat((_k = statusMap.get(Status.PEER_ID_INVALID)) !== null && _k !== void 0 ? _k : 0, "\n                 NO_RIGHTS: ").concat((_l = statusMap.get(Status.NO_RIGHTS)) !== null && _l !== void 0 ? _l : 0, "\n                 SG_NO_MEMBER: ").concat((_m = statusMap.get(Status.SG_NO_MEMBER)) !== null && _m !== void 0 ? _m : 0, "\n                 CHANNEL_PRIVATE: ").concat((_o = statusMap.get(Status.CHANNEL_PRIVATE)) !== null && _o !== void 0 ? _o : 0, "\n                 OTHER: ").concat((_p = statusMap.get(Status.OTHER)) !== null && _p !== void 0 ? _p : 0, "\n                 TOTAL: ").concat(resultMap.size, " of ").concat(ids.length, " (").concat((100 * resultMap.size / ids.length).toFixed(), "%)\n\n                 ").concat(errorLog.join('\n'), "\n                 ").split('\n');
    var data = lines.map(function (line) {
        var trimmed = line.trimStart();
        if (trimmed.includes(':')) {
            return trimmed.substring(0, trimmed.indexOf(':') + 1).padEnd(20)
                + BG_BLUE_FG_YELLOW
                + trimmed.substring(trimmed.indexOf(':') + 1)
                + ' ' + FG_BG_RESET;
        }
        return line;
    }).join('\n');
    console.log(data);
};
var set = function (id, status) {
    var _a;
    resultMap.set(id, status);
    statusMap.set(status, ((_a = statusMap.get(status)) !== null && _a !== void 0 ? _a : 0) + 1);
};
var checkBlocked = function (id) { return __awaiter(void 0, void 0, void 0, function () {
    var request, _a, ok, result, error_1, description, status_1;
    var _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                _c.trys.push([0, 2, , 8]);
                return [4 /*yield*/, (0, axios_1["default"])("https://api.telegram.org/bot".concat(botToken, "/sendChatAction?action=typing&chat_id=").concat(id))];
            case 1:
                request = _c.sent();
                _a = request.data, ok = _a.ok, result = _a.result;
                if (ok && result) {
                    set(id, Status.OK);
                }
                else {
                    set(id, Status.OTHER);
                    console.log(id, ok, result);
                }
                return [3 /*break*/, 8];
            case 2:
                error_1 = _c.sent();
                if (!!error_1.response) return [3 /*break*/, 6];
                if (!(error_1.message === ENOTFOUND)) return [3 /*break*/, 4];
                return [4 /*yield*/, new Promise(function (rs) { return setTimeout(rs, 300 + Math.random() * 300); })];
            case 3:
                _c.sent();
                return [2 /*return*/, checkBlocked(id)];
            case 4:
                errorLog.push("".concat(id, " ").concat(error_1.message));
                if (errorLog.length > 10) {
                    errorLog.shift();
                }
                _c.label = 5;
            case 5: return [3 /*break*/, 7];
            case 6:
                description = error_1.response.data.description;
                status_1 = (_b = MAP_STATUSES[description]) !== null && _b !== void 0 ? _b : Status.OTHER;
                set(id, status_1);
                if (status_1 === Status.OTHER) {
                    console.log(id, description);
                }
                _c.label = 7;
            case 7: return [3 /*break*/, 8];
            case 8:
                if (resultMap.size % 10 === 0 || resultMap.size === ids.length) {
                    echo();
                }
                return [2 /*return*/];
        }
    });
}); };
var promises = [];
var START_FROM = 0;
var main = function () { return __awaiter(void 0, void 0, void 0, function () {
    var counter, _loop_1, _i, ids_1, id;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                counter = 0;
                _loop_1 = function (id) {
                    var promise, i;
                    return __generator(this, function (_b) {
                        switch (_b.label) {
                            case 0:
                                if (counter < START_FROM) {
                                    counter++;
                                    return [2 /*return*/, "continue"];
                                }
                                else {
                                    counter++;
                                }
                                promise = checkBlocked(id);
                                promise.then(function () {
                                    promise.done = true;
                                });
                                promises.push(promise);
                                if (!(promises.length >= MAX_THREADS)) return [3 /*break*/, 2];
                                return [4 /*yield*/, Promise.race(promises)];
                            case 1:
                                _b.sent();
                                for (i = promises.length - 1; i >= 0; i--) {
                                    if (promises[i].done) {
                                        promises.splice(i, 1);
                                    }
                                }
                                _b.label = 2;
                            case 2: return [2 /*return*/];
                        }
                    });
                };
                _i = 0, ids_1 = ids;
                _a.label = 1;
            case 1:
                if (!(_i < ids_1.length)) return [3 /*break*/, 4];
                id = ids_1[_i];
                return [5 /*yield**/, _loop_1(id)];
            case 2:
                _a.sent();
                _a.label = 3;
            case 3:
                _i++;
                return [3 /*break*/, 1];
            case 4: return [2 /*return*/];
        }
    });
}); };
main();
